﻿// ConfigBasic.cpp : 备泅 颇老涝聪促.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "NeMessengerDlg.h"
#include "ConfigBasic.h"
#include "CommonFunction.h"


// CConfigBasic 措拳 惑磊涝聪促.

LPCTSTR c_languageArray[5][3] = {{_T("선택하신 언어로 변경하려면 Ntalk을 재실행해야 합니다. \r\n지금 재실행하시겠습니까?"), _T("예"), _T("아니요")}, 
							{_T("You must restart Ntalk for the language changes to take effect. \r\nDo you want to restart it now?"), _T("Yes"), _T("No")}, 
							{_T("選択した言語に変更するには、Ntalkを再実行する必要があります。\r\n今、再実行しますか?"), _T("はい"), _T("いいえ")}, 
							{_T("必須重啟Ntalk才能使語言變更生效，要現在重啟嗎？"), _T("是 "), _T("不是")},
							{_T("必须重启Ntalk才能使语言变更生效，要现在重启吗？"), _T("是 "), _T("不是")}};

IMPLEMENT_DYNAMIC(CConfigBasic, CConfigBaseDlg)

CConfigBasic::CConfigBasic(CWnd* pParent /*=NULL*/)
	: CConfigBaseDlg(CConfigBasic::IDD, pParent)
{
    m_rcAutoStartText.SetRect(112,32,360,15+32);
    m_rcNoteAlertText.SetRect(112,56,360,31+57);
    m_rcFavoriteAlertText.SetRect(112,96,360,31+99);
    m_nCurrentLanguage = 0;
}

CConfigBasic::~CConfigBasic()
{
}

void CConfigBasic::DoDataExchange(CDataExchange* pDX)
{
	CConfigBaseDlg::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_AUTO_START_CHECK, m_chkAutoStart);
	DDX_Control(pDX, IDC_START_MEMO_VIEW_CHECK, m_chkStartMemo);
	DDX_Control(pDX, IDC_FOVORITE_TRAY_CHECK, m_chkFovoriteTray);
	DDX_Control(pDX, IDC_GMT_COMBO, m_cmbGMT);
	DDX_Control(pDX, IDC_LANGUAGE_COMBO, m_cmbLanguage);
}

BEGIN_MESSAGE_MAP(CConfigBasic, CConfigBaseDlg)
	ON_WM_ERASEBKGND()
	ON_CBN_SELENDOK(IDC_LANGUAGE_COMBO, &CConfigBasic::OnCbnSelendokLanguageCombo)
END_MESSAGE_MAP()

BOOL CConfigBasic::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			
			return TRUE;
		}
	}
	else if(pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}
BOOL CConfigBasic::OnInitDialog()
{
	CConfigBaseDlg::OnInitDialog();	

	m_chkAutoStart.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));
	m_chkFovoriteTray.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));
	m_chkStartMemo.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));	

	m_cmbGMT.SetFont(&g_ftDefault9PT);
	m_cmbGMT.SetTextColor(RGB(0x66, 0x66, 0x66));
	m_cmbLanguage.SetFont(&g_ftDefault9PT);
	m_cmbLanguage.SetTextColor(RGB(0x66, 0x66, 0x66));
	m_cmbGMT.AddWorldTimeStrings();
	
	CString str;
	m_cmbGMT.SetCurSel(GET_CONFIG()->GetGMT());
	str.LoadString(IDS_STRING401);//茄惫绢
	m_cmbLanguage.AddString(str);
	str.LoadString(IDS_STRING402);//English
	m_cmbLanguage.AddString(str);
	str.LoadString(IDS_STRING403);//祉茆遛
	m_cmbLanguage.AddString(str);
	str.LoadString(IDS_STRING404);//耖闲遛(TRADITIONAL)
	m_cmbLanguage.AddString(str);
	str.LoadString(IDS_STRING405);//耖闲遛(SIMPLIFIED)
	m_cmbLanguage.AddString(str);
	m_cmbLanguage.SetCurSel(GET_CONFIG()->GetLanguage());
	
	m_chkAutoStart.MoveWindow(100,34,11,11,TRUE);
	m_chkStartMemo.MoveWindow(100,58,11,11,TRUE);
	m_chkFovoriteTray.MoveWindow(100,98,11,11,TRUE);	
	m_cmbLanguage.MoveWindow(100, 159, 260, 21,TRUE);
	m_cmbGMT.MoveWindow(100, 205, 260, 21, TRUE);

	AddClickAssociateInfo(&m_chkAutoStart, m_rcAutoStartText);
	AddClickAssociateInfo(&m_chkStartMemo, m_rcNoteAlertText);
	AddClickAssociateInfo(&m_chkFovoriteTray, m_rcFavoriteAlertText);

	initData();
	return TRUE;
}


void CConfigBasic::initData()
{
	int nValue = GET_CONFIG()->GetAutoStart();
	DDX_CHECKBOX_VALUE(m_chkAutoStart,nValue,FALSE);
	nValue = GET_CONFIG()->GetAutoMessageView();
	DDX_CHECKBOX_VALUE(m_chkStartMemo,nValue,FALSE);
	nValue = GET_CONFIG()->GetFavoriteTray();
	DDX_CHECKBOX_VALUE(m_chkFovoriteTray,nValue,FALSE);
	m_cmbGMT.SetCurSel(GET_CONFIG()->GetGMT());
	m_cmbLanguage.SetCurSel(GET_CONFIG()->GetLanguage());
	m_nCurrentLanguage = m_cmbLanguage.GetCurSel();
	UpdateData(FALSE);
}

void CConfigBasic::DoApply()
{
	UpdateData(TRUE);
	int nValue = 0;
	DDX_CHECKBOX_VALUE(m_chkAutoStart,nValue,TRUE);
	GET_CONFIG()->SetAutoStart(nValue);
	DDX_CHECKBOX_VALUE(m_chkStartMemo,nValue,TRUE);
	GET_CONFIG()->SetAutoMessageView(nValue);
	DDX_CHECKBOX_VALUE(m_chkFovoriteTray,nValue,TRUE);
	GET_CONFIG()->SetFavoriteTray(nValue);

	GET_CONFIG()->SetGMT(m_cmbGMT.GetCurSel());
	GET_CONFIG()->SetLanguage(m_cmbLanguage.GetCurSel());
}

BOOL CConfigBasic::OnEraseBkgnd(CDC* pDC)
{
	BOOL bRet =	CConfigBaseDlg::OnEraseBkgnd(pDC);
	
	CRect rcTitleText(0, 0, 0, 0);
	rcTitleText.SetRect(20,32,20+75,32+18);
	CString str;

	CFont *pOldFont = pDC->SelectObject(&g_ftDefault10PT);
	COLORREF oldColor = pDC->SetTextColor(RGB(34,34,34));
	pDC->SetBkMode(TRANSPARENT);
	str.LoadString(IDS_STRING406);//老馆
	pDC->DrawText(str,rcTitleText,DT_LEFT);
	rcTitleText.top = rcTitleText.top +130;
	rcTitleText.bottom = rcTitleText.bottom +130;
	str.LoadString(IDS_STRING407);//攫绢函版
	pDC->DrawText(str,rcTitleText,DT_LEFT);
	rcTitleText.top = rcTitleText.top +46;
	rcTitleText.bottom = rcTitleText.bottom +46;
	str.LoadString(IDS_STRING408);//扁霖矫埃
	pDC->DrawText(str,rcTitleText,DT_LEFT);
	pDC->SelectObject(&g_ftDefault9PT);
	pDC->SetTextColor(RGB(102,102,102));
	str.LoadString(IDS_STRING409);//扩档快 矫累矫 磊悼角青
	pDC->DrawText(str,m_rcAutoStartText,DT_LEFT);

	str.LoadString(IDS_STRING410);//肺弊牢矫 固犬牢 率瘤唱 舅覆阑 皋矫瘤 包府...
	DrawIntervalMessageText(pDC, str, m_rcNoteAlertText, DT_TOP | DT_LEFT, 2);
	//pDC->DrawText(str,m_rcNoteAlertText,DT_LEFT);
	str.LoadString(IDS_STRING411);//榴败茫扁 措拳惑措 肺弊牢矫 葛萍磐...
	DrawIntervalMessageText(pDC, str, m_rcFavoriteAlertText, DT_TOP | DT_LEFT, 2);
	//pDC->DrawText(str,m_rcFavoriteAlertText,DT_LEFT);


	pDC->SetTextColor(oldColor);	
	pDC->SelectObject(pOldFont);
	

	return bRet;
}

void CConfigBasic::OnCbnSelendokLanguageCombo()
{
	if(m_cmbLanguage.GetCurSel() != m_nCurrentLanguage)
	{
		m_nCurrentLanguage = m_cmbLanguage.GetCurSel();

		CString str = c_languageArray[m_nCurrentLanguage][0];
		//str.LoadString(IDS_SETTING_CHANGE_LANGUAGE_CONFIRM);
		
		if(IDYES == NMessageBox(this,str,_T("Ntalk Biz"), MB_YESNO, FALSE, _T(""), _T(""),FALSE, c_languageArray[m_nCurrentLanguage][1], c_languageArray[m_nCurrentLanguage][2]))
		{
			
			CConfigDlg* pParent = dynamic_cast<CConfigDlg*>(this->GetParent());
			if(NULL != pParent)
			{
				pParent->OnBnClickedSaveButton();
			}
			if(NULL != g_pMain)
			{
				g_pMain->OnTopMenuExit();
				GET_APP()->ExitThenRun();
			}
		}
	}
}
